// See CounterSecondTry.cpp from the C++11 threads lab part 1,
// where the same functionality is programmed using mutex and lock guards.

#include <iostream>
#include <vector>
#include <thread>
#include <atomic>

using namespace std;

void incrementCounter(atomic<int> &counter) {
    for (int i = 0; i < 10000000; i++) {
        // Faster than mutex!
        counter.fetch_add(1);
    }
}

int main() {
    atomic<int> counter;
    counter = 0;

    vector<thread> workers;
    for (int workerIndex = 0; workerIndex < 4; workerIndex++) {
        workers.push_back(thread(incrementCounter, ref(counter)));
    }

    for (auto &worker : workers) {
        worker.join();
    }

    cout << "Value of the counter variable: " << counter << endl;

    return 0;
}
